ACM-经典DP之Monkey and Banana——hdu1069

简介:

***************************************转载请注明出处:http://blog.csdn.net/lttree***************************************

Monkey and Banana

Time Limit: 2000/1000 MS (Java/Others)    Memory Limit: 65536/32768 K (Java/Others)
Total Submission(s): 6984    Accepted Submission(s): 3582

Problem Description
A group of researchers are designing an experiment to test the IQ of a monkey. They will hang a banana at the roof of a building, and at the mean time, provide the monkey with some blocks. If the monkey is clever enough, it shall be able to reach the banana by placing one block on the top another to build a tower and climb up to get its favorite food.

The researchers have n types of blocks, and an unlimited supply of blocks of each type. Each type-i block was a rectangular solid with linear dimensions (xi, yi, zi). A block could be reoriented so that any two of its three dimensions determined the dimensions of the base and the other dimension was the height. 

They want to make sure that the tallest tower possible by stacking blocks can reach the roof. The problem is that, in building a tower, one block could only be placed on top of another block as long as the two base dimensions of the upper block were both strictly smaller than the corresponding base dimensions of the lower block because there has to be some space for the monkey to step on. This meant, for example, that blocks oriented to have equal-sized bases couldn't be stacked. 

Your job is to write a program that determines the height of the tallest tower the monkey can build with a given set of blocks.
 

Input
The input file will contain one or more test cases. The first line of each test case contains an integer n,
representing the number of different blocks in the following data set. The maximum value for n is 30.
Each of the next n lines contains three integers representing the values xi, yi and zi.
Input is terminated by a value of zero (0) for n.
 

Output
For each test case, print one line containing the case number (they are numbered sequentially starting from 1) and the height of the tallest possible tower in the format "Case case: maximum height = height".
 

Sample Input
 
 
1 10 20 30 2 6 8 10 5 5 5 7 1 1 1 2 2 2 3 3 3 4 4 4 5 5 5 6 6 6 7 7 7 5 31 41 59 26 53 58 97 93 23 84 62 64 33 83 27 0
 

Sample Output
 
 
Case 1: maximum height = 40 Case 2: maximum height = 21 Case 3: maximum height = 28 Case 4: maximum height = 342
 

Source
 


一道经典的DP题目,类似于求最长递增子序列吧。

题意:
一堆科学家研究猩猩的智商。给他M种长方体,每种N个。

然后。将一个香蕉挂在屋顶。让猩猩通过 叠长方体来够到香蕉。


如今给你M种长方体,计算。最高能堆多高。
要求位于上面的长方体的长要大于(注意不是大于等于)以下长方体的长,上面长方体的宽大于以下长方体的宽。

解题:
一个长方体,能够有6种不同的摆法。
由于数据中 长方体种类最多30种,也就是说数组最大能够开到 30*6=180 全然能够

然后用dp[i]来存,到第i个木块,最高能够累多高。

当然,长方体先要以长度排序,长度同样则宽度小的在上。

(⊙v⊙)嗯,OK~

/****************************************
*****************************************
*        Author:Tree                    *
*From :http://blog.csdn.net/lttree      *
* Title : monkey and banana             *
*Source: hdu 1069                       *
* Hint  : dp                            *
*****************************************
****************************************/

#include <iostream>
#include <algorithm>
using namespace std;
struct Cuboid
{
    int l,w,h;
}cd[181];
int dp[181];
// sort比較函数
bool cmp( Cuboid cod1,Cuboid cod2 )
{
    if( cod1.l==cod2.l )    return cod1.w<cod1.w;
    return cod1.l<cod2.l;
}
int main()
{
    int i,j,n,len,t_num=1;
    int z1,z2,z3;
    while( cin>>n && n )
    {
        len=0;
        // 每组数都能够变换为6种长方体
        for(i=0;i<n;++i)
        {
            cin>>z1>>z2>>z3;
            cd[len].l=z1,cd[len].w=z2,cd[len++].h=z3;
            cd[len].l=z1,cd[len].w=z3,cd[len++].h=z2;
            cd[len].l=z2,cd[len].w=z1,cd[len++].h=z3;
            cd[len].l=z2,cd[len].w=z3,cd[len++].h=z1;
            cd[len].l=z3,cd[len].w=z1,cd[len++].h=z2;
            cd[len].l=z3,cd[len].w=z2,cd[len++].h=z1;
        }

        sort(cd,cd+len,cmp);
        dp[0]=cd[0].h;
        
        // 构建dp数组
        int max_h;
        for(i=1;i<len;++i)
        {
            max_h=0;
            for( j=0;j<i;++j )
            {
                if( cd[j].l<cd[i].l && cd[j].w<cd[i].w )
                    max_h=max_h>dp[j]?max_h:dp[j];
            }
            dp[i]=cd[i].h+max_h;
        }
        
        // 再次搜索 全部dp中最大值
        max_h=0;
        for(i=0;i<len;++i)
            if( max_h<dp[i] )
                max_h=dp[i];
        // 输出
        cout<<"Case "<<t_num++<<": maximum height = "<<max_h<<endl;
    }
    return 0;
}






本文转自mfrbuaa博客园博客,原文链接:http://www.cnblogs.com/mfrbuaa/p/5412420.html,如需转载请自行联系原作者
相关文章
|
9月前
UVa12032 - The Monkey and the Oiled Bamboo(贪心)
UVa12032 - The Monkey and the Oiled Bamboo(贪心)
35 0
HDU 3506 Monkey Party(动态规划)
HDU 3506 Monkey Party(动态规划)
46 0
HDU 3506 Monkey Party(动态规划)
HDU-1002,A + B Problem II(Java大数)
HDU-1002,A + B Problem II(Java大数)
|
人工智能 BI 算法
|
机器学习/深度学习 Java 网络架构